let angle = 0;  // determines the starting angle for the ellipses in each loop
let offset = 100; // used to control the spacing between each ellipse
let scalar = 50; //  controls the size of the ellipses

function setup() {
  createCanvas(400, 400); // creates a canvas with a width of 400 pixels and a height of 400 pixels
}

function draw() {
  background(0); // sets the background colour to black
  noFill(); // stops the shapes on the canvas being filled

  push(); // creates a new drawing state
  translate(width/2 + 100, height/2 + 100); // translates the coordinate system to the center plus 100px in x and y which puts this shape to the bottom right of the canvas 
  // creates a loop which draws an ellipse 25 times
  for (let i = 0; i < 25; i++) {
    stroke(255, 231, 53); // sets the color of this ellipse to yellow
    // the cos and sin functions are used to calculate the x and y coordinates of the ellipse, based on the value of angle and offset.
    let x = cos(angle + offset * i) * scalar; 
    let y = sin(angle + offset * i) * scalar;
    ellipse(x, y, scalar, scalar); // the ellipse function draws an ellipse at the specified coordinates with the specified width and height.
  }
  pop(); // resets drawing state to previous

  push(); // creates a new drawing state
  translate(width/2, height/2); // translates the coordinate system to the center of the canvas for the first ellipse
  

  // creates a loop which draws an ellipse 40 times. 
  for (let i = 0; i < 40; i++) {
    stroke(210, 4, 45); // sets the color of this ellipse to red
  // same as the previous loop
    let x = cos(angle + offset * i) * scalar;
    let y = sin(angle + offset * i) * scalar;
    ellipse(x, y, scalar, scalar); // same as the previous loop
  }
  pop(); // resets drawing state to previous


  push(); // creates a new drawing state
  translate(width/2 - 100, height/2 - 100); // translates the coordinate system to the center minus 100px in x and y which puts this shape to the top left of the canvas 
  // creates a loop which draws an ellipse 60 times
  for (let i = 0; i < 60; i++) {
    stroke(112, 147, 255); // sets the color of this ellipse to purple
    // the rest of the code is the same as above
    let x = cos(angle + offset * i) * scalar; 
    let y = sin(angle + offset * i) * scalar;
    ellipse(x, y, scalar, scalar);
  }
  pop(); // resets drawing state to previous
}
